class Operation
  attr_reader :metadata, :code

  def initialize(options = {})
    @options = options
  end

  def success?
    [true, 'true', 1, '1'].include? options[:success]
  end

  def failure?
    !success?
  end

  def code
    return if options[:code].to_s == ''
    options[:code].to_s.to_sym
  end

  # Convenience Wrapper
  def object
    meta[:object] || meta['object'] || meta.object
  rescue
    nil
  end

  def metadata
    options[:metadata]
  end

  def meta
    if defined? Hashie::Mash
      metamash
    else
      metadata
    end
  end

  def metamash
    if metadata.respond_to? :each_pair
      Hashie::Mash.new metadata
    elsif metadata
      metadata
    else
      Hashie::Mash.new
    end
  end

  private

  attr_reader :options

end
